%NTCALL macro Id, pArg
	mov eax,Id
	mov edx,pArg
	Int 2Eh
endm

; :HANDLE
_NtUserQueryWindow struct
hwnd			HWND ?
WindowInfo	ULONG ?	; WINDOWINFOCLASS
_NtUserQueryWindow ends

; WINDOWINFOCLASS
; 5.1/6.1
WindowThread		equ 0
WindowProcess		equ 1
WindowIsHung		equ 4

pNtUserQueryWindow proc C
	assume ebx:ptr _NtUserQueryWindow
	retn
pNtUserQueryWindow endp

; +
;   EP User32.
;
pUserClientDllInitialize proc C
	%RPUSH
	invoke TlsGet
	xor edx,edx
	.if TLS_ENTRY.User[TLS_PRE][Eax] != Edx
		xchg TLS_ENTRY.User[TLS_PRE][eax],edx
		mov RSTATE.R.rEdx[esp],edx	; Ip'
	.endif
	.if !TLS_ENTRY.User[TLS_POST][Eax]	;   .
		cmp fs:[PcStackBase],ebp
		mov edx,offset pUserClientDllInitialize2nd
		jna Exit
		cmp fs:[PcStackLimit],ebp
		ja Exit
		xchg STACK_FRAME.Ip[ebp],edx
		mov TLS_ENTRY.User[TLS_POST][Eax],edx
	.endif
Exit:
	%RPOP
	jmp Edx
pUserClientDllInitialize endp

PUBLIC g_NtUserInitialized

.data
align 4
NTUSER struct
Id			ULONG ?
Handler		PVOID ?
NTUSER ends
PNTUSER typedef ptr NTUSER

g_NtUserInitialized			BOOLEAN ?

NtUserList				ULONG 1	; *      !
g_NtUserQueryWindow			NTUSER <?, pNtUserQueryWindow>

.code
; +
;  ID  .
;
InitShadow proc
Local Ldr:PLDR_DATA_TABLE_ENTRY
Local Api[2]:PVOID
	mov eax,fs:[TEB.Peb]
	cmp PEB.KernelCallbackTable[eax],NULL
	je Exit
	cmp g_NtUserInitialized,FALSE
	jne Exit
	
	invoke TlsAdd
	mov ebx,eax
	assume ebx:PTLS_ENTRY
	
	mov [ebx].Id,offset g_NtUserQueryWindow
	push NULL
	push g_ShellPid
	Call g_UserApi.pGetWindowThreadProcessId
	
	mov [ebx].Id,NULL
	mov g_NtUserInitialized,TRUE
Exit:
	ret	
InitShadow endp

; +
;
GetShellPid proc
	Call g_UserApi.pGetShellWindow
	.if Eax
		push eax
		push esp
		push eax
		Call g_UserApi.pGetWindowThreadProcessId
		test eax,eax
		pop eax
	.endif
	ret
GetShellPid endp

; +
;   EP User32  ntldr.
;
pUserClientDllInitialize2nd proc C
	%RPUSH
	.if !g_NtUserInitialized
		invoke LdrEncodeEntriesList, g_UserBase, addr g_UserApi
		.if !Eax
			invoke GetShellPid
			mov g_ShellPid,eax
			invoke InitShadow
		.endif
	.endif
	invoke TlsGet
	xor edx,edx
	xchg TLS_ENTRY.User[TLS_POST][eax],edx
	mov D[esp + sizeof(RSTATE)],edx	; Ip'
	%RPOP
	ret
pUserClientDllInitialize2nd endp

; ~~~~~~~~~~~~~~~~ USER API ~~~~~~~~~~~~~~~~

pRtlDecodePointer proc C
	%RPUSH
	%DBG "pRtlDecodePointer exited."
	%RPOP
	%RLOAD pRtlDecodePointer
pRtlDecodePointer endp
