PARSEINFO struct
S1ze		ULONG ?
N		ULONG ?
PARSEINFO ends
PPARSEINFO typedef ptr PARSEINFO

; +
;
;      .
;
ZwParseCallbackI proc Info:PPARSEINFO, $Name:PSTR, S1ze:ULONG
	mov edx,Info
	mov eax,$Name
	mov ecx,S1ze
	.if (Ecx > 6) && W[Eax] == 'wZ'
		add PARSEINFO.S1ze[edx],ecx
		inc PARSEINFO.N[edx]
		inc PARSEINFO.S1ze[edx]	; EOL
	.endif
	xor eax,eax
	ret
ZwParseCallbackI endp

; +
;
;   .
;
GenerateZwList proc uses ebx esi edi
Local ImageHeader:PIMAGE_NT_HEADERS
Local ExportDirectory:PIMAGE_EXPORT_DIRECTORY
Local NumberOfNames:ULONG
Local Info:PARSEINFO
Local pNtList:PVOID
	mov ebx,g_NtView
	mov Info.S1ze,0
	mov Info.N,0
	invoke LdrImageQueryEntryFromHash, Ebx, addr Info, offset ZwParseCallbackI, addr Info, NULL	;   .
	mov ecx,Info.N
	shl ecx,4	; NTID.Name = 8
	add Info.S1ze,ecx
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr g_NtList, 0, addr Info.S1ze, MEM_COMMIT, PAGE_READWRITE
	mov ecx,g_NtList
	test eax,eax
	mov pNtList,ecx
	jnz Exit
	invoke LdrImageNtHeader, Ebx, addr ImageHeader
	test eax,eax
	mov ecx,ImageHeader
	jnz Exit
	assume ecx:PIMAGE_NT_HEADERS
	mov eax,[ecx].OptionalHeader.DataDirectory.VirtualAddress
	test eax,eax
	jz Error
	add eax,ebx
	assume eax:PIMAGE_EXPORT_DIRECTORY	
	mov ExportDirectory,eax
	mov esi,[eax].AddressOfNames
	test esi,esi
	mov eax,[eax].NumberOfNames
	jz Error
	test eax,eax
	mov NumberOfNames,eax
	jz Error
	add esi,ebx
	xor edi,edi
	cld
Next:
	push esi
	push edi
	mov edx,D[esi]
	mov ecx,MAX_PATH
	add edx,ebx
	mov edi,edx
	xor eax,eax
	repne scasb
	not ecx
	add ecx,MAX_PATH
	.if (Ecx > 6) && W[Edx] == 'wZ'
		mov edi,pNtList
		mov NTID.S1ze[edi],ecx
		push ecx
		add edi,NTID.Nam3
		inc ecx
		mov esi,edx
		push edi
		rep movsb
		push 0
		Call LdrCalculateHash
		mov ecx,pNtList
		mov edx,D[esp]
		mov NTID.Hash[ecx],eax
		mov ecx,ExportDirectory
		assume ecx:PIMAGE_EXPORT_DIRECTORY
		mov eax,[ecx].AddressOfNameOrdinals
		add eax,ebx
		movzx edx,W[2*edx + eax]
		.if Edi
			.if Edx >= [Ecx]._Base
				sub edx,[ecx]._Base
			.endif
			inc edx
		.endif
		mov esi,[ecx].AddressOfFunctions
		add esi,ebx
		mov ecx,D[4*edx + esi]
		mov edx,pNtList
		mov NTID.Rva[edx],ecx
		mov pNtList,edi
		add ecx,ebx
		cmp B[ecx],0B8H	; mov eax,Id
		mov eax,D[ecx + 1]
		jne Error
		mov NTID.Id[edx],eax
	.endif
	pop edi
	pop esi
	inc edi
	add esi,4
	dec NumberOfNames
	jnz Next
	mov ecx,pNtList
	xor eax,eax
	mov g_NtListN,ecx
Exit:
	ret
Error:
	mov eax,STATUS_UNSUCCESSFUL
	jmp Exit
GenerateZwList endp

PUBLIC FltIdToNTID

; +
;
;    ID.
;
FltIdToNTID proc uses ebx Id:ULONG
	cmp g_Init,FALSE
	je Fail
	mov eax,g_NtList
	mov ecx,g_NtListN
	mov ebx,Id
@@:
	mov edx,NTID.S1ze[eax]
	cmp NTID.Id[eax],ebx
	je Exit
	lea eax,[eax + edx + NTID.Nam3 + 1]
	cmp eax,ecx
	jb @b
Fail:
	xor eax,eax
Exit:
	ret
FltIdToNTID endp

PUBLIC FltHashToNTID

; +
;
;     .
;
FltHashToNTID proc uses ebx Hash:ULONG
	cmp g_Init,FALSE
	je Fail
	mov eax,g_NtList
	mov ecx,g_NtListN
	mov ebx,Hash
@@:
	mov edx,NTID.S1ze[eax]
	cmp NTID.Hash[eax],ebx
	je Exit
	lea eax,[eax + edx + NTID.Nam3 + 1]
	cmp eax,ecx
	jb @b
Fail:
	xor eax,eax
Exit:
	ret
FltHashToNTID endp

PUBLIC FltNameToNTID

; +
;
;    .
;
FltNameToNTID proc uses esi edi Nam3:PSTR
	cmp g_Init,FALSE
	je Fail
	cld
	mov eax,g_NtList
@@:
	mov esi,Nam3
	mov ecx,NTID.S1ze[eax]
	lea edi,NTID.Nam3[eax]
	inc ecx
	mov edx,NTID.S1ze[eax]
	repe cmpsb
	je Exit
	lea eax,[eax + edx + NTID.Nam3 + 1]
	cmp g_NtListN,eax
	jnb @b
Fail:
	xor eax,eax
Exit:
	ret
FltNameToNTID endp